models/Formulario.php
<?php

namespace app\models;

use yii\base\Model;

class Formulario extends Model
{
    public ?int $activado = null;
    public ?string $mes = null;
    public ?string $opcion = null;
    public array $dias = [];
    public ?int $id = null;
    public ?string $fecha = null;
    public $archivo; // se almacena el archivo subido como objeto


    public function rules(): array
    {
        return [
            [['mes', 'opcion', 'dias', 'id'], 'required'],
            [['activado', 'fecha'], 'safe'],
            [
                ['archivo'], 'file',
                'skipOnEmpty' => false, // obligatorio seleccionas una imagen
                'extensions' => 'pdf' // extensiones permitidas
            ],
        ];
    }

    public function attributeLabels(): array
    {
        return [
            "activado" => "Activado",
            "mes" => "Mes de reserva",
            "opcion" => "Opciones a elegir",
            "dias" => "Seleccione uno o varios dias",
            "id" => "Id",
            "fecha" => "Fecha Reserva",
            "archivo" => "Suba archivo pdf",
        ];
    }
    public function subirArchivo(): bool
    {
        $this->archivo->saveAs('pdf/' . $this->archivo->name);
        return true;
    }

    /**
     * antes de validar cojo los archivos enviados y
     * los coloco en el modelo
     * 
     */
    public function beforeValidate()
    {
        $this->archivo = \yii\web\UploadedFile::getInstance($this, 'archivo');
        return true;
    }


    /**
     * despues de validar subo el archivo
     * 
     */
    public function afterValidate()
    {
        $this->subirArchivo();
        return true;
    }

    public function meses(): array
    {
        return [
            "enero" => "Enero",
            "febrero" => "Febrero"
        ];
    }

    public function opciones(): array
    {
        return [
            "opcion 1" => "Opcion 1",
            "opcion 2" => "Opcion 2",
            "opcion 3" => "Opcion 3"
        ];
    }

    public function diasMostrar(): array
    {
        return [
            "lunes" => "Lunes",
            "martes" => "Martes"
        ];
    }

    public function getDiasseleccionados()
    {
        return join(",", $this->dias);
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Formulario;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\helpers\FileHelper;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    public function actionFormulario()
    {
        $model = new Formulario();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render("solucion", [
                    "model" => $model
                ]);
            }
        }

        return $this->render('formulario', [
            'model' => $model,
        ]);
    }

    public function actionFicheros()
    {
        $ficheros = FileHelper::findFiles('./pdf');
        foreach ($ficheros as $indice => $fichero) {
            $ficheros[$indice] = substr($fichero, strpos($fichero, '\\') + 1);
        }

        // utilizo compact para enviar argumento como 
        // array asociativo
        return $this->render('ficheros', compact("ficheros"));
        // return $this->render('ficheros', [
        //     "ficheros" => $ficheros
        // ]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">

<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>

<body class="d-flex flex-column h-100">
    <?php $this->beginBody() ?>

    <header id="header">
        <?php
        NavBar::begin([
            'brandLabel' => Yii::$app->name,
            'brandUrl' => Yii::$app->homeUrl,
            'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
        ]);
        echo Nav::widget([
            'options' => ['class' => 'navbar-nav'],
            'items' => [
                ['label' => 'Home', 'url' => ['/site/index']],
                ['label' => 'Formulario', 'url' => ['/site/formulario']],
                ['label' => 'Ficheros Subidos', 'url' => ['/site/ficheros']],
            ]
        ]);
        NavBar::end();
        ?>
    </header>

    <main id="main" class="flex-shrink-0" role="main">
        <div class="container">
            <?php if (!empty($this->params['breadcrumbs'])) : ?>
                <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
            <?php endif ?>
            <?= Alert::widget() ?>
            <?= $content ?>
        </div>
    </main>

    <footer id="footer" class="mt-auto py-3 bg-light">
        <div class="container">
            <div class="row text-muted">
                <div class="col-md-6 text-center text-md-start">Alpe Formacion 2023</div>
                <div class="col-md-6 text-center text-md-end">Ramon Abramo</div>
            </div>
        </div>
    </footer>

    <?php $this->endBody() ?>
</body>

</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/ficheros.php
<?php

use yii\helpers\Html;

foreach ($ficheros as $fichero) {
    echo "<div>";
    echo Html::a($fichero, '@web/pdf/' . $fichero, ["class" => "btn btn-primary"]);
    echo "</div><br>";
}

views/site/formulario.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario">

    <?php $form = ActiveForm::begin(); ?>

    <?=
    $form
        ->field($model, 'activado')
        ->checkbox()
    ?>
    <?=
    $form
        ->field($model, 'mes')
        ->dropDownList($model->meses())
    ?>
    <?=
    $form
        ->field($model, 'opcion')
        ->radioList($model->opciones())
    ?>
    <?=
    $form
        ->field($model, 'dias')
        ->listBox($model->diasMostrar(), [
            'multiple' => 'multiple'
        ])
    ?>
    <?=
    $form
        ->field($model, 'id')
        ->input('number')
    ?>
    <?=
    $form
        ->field($model, 'fecha')
        ->input('date')
    ?>
    <?=
    $form
        ->field($model, 'archivo')
        ->fileInput();
    ?>

    <div class="form-group">
        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario -->

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Formularios';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Formularios 5</h1>

        <p class="lead">Gestion de Formularios con MVC</p>

    </div>


</div>

views/site/solucion.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'activado',
        'mes',
        'opcion',
        'id',
        'fecha',
        [
            "attribute" => 'archivo',
            "format" => "raw",
            "value" => function ($model) {
                return Html::a(
                    $model->archivo->name,
                    '@web/pdf/' . $model->archivo->name,
                    ["class" => "btn btn-primary"]
                );
            }
        ],
        "DiasSeleccionados"
    ]
]);